-- CreaquickslotRowsted by NuclearTonic
-- The use of this code requires the permission of the author.
-- Permission can be atained by contacting NuclearTonic at: TonicBars@gmail.com
--
-- RESPECT!

import "Turbine";
import "Tonic.Utils.Class";
import "Turbine.Gameplay";
import "Tonic.Utils.TableDeepCopy";

SettingsManager = class( Turbine.Object );

function SettingsManager:Constructor()
	self.PARTIAL = 1;
	self.ALL = 2;
	self.BAR = 3;

	self:LoadSettings();
	
	if ( self.settings.bars ~= nil ) then
		for bKey, bValue in pairs (self.settings.bars) do
			if (tonumber(bValue.x)) then
			
			end
			if (tonumber(bValue.y)) then
			
			end

		end
	end	
	
end

function SettingsManager:GetSettings()
	return self.settings;
end

function SettingsManager:LoadSettings( profile )
	if ( profile == nil ) then
		self.profiles = Turbine.PluginData.Load( Turbine.DataScope.Server, "TonicBarSettings" );
	else
		self.profiles = profile;
	end
	if ( self.profiles == nil ) then
		self.profiles = { };
	end
	local playerSettings = self.profiles[ player:GetName() ];
	if ( playerSettings == nil ) then
		self.profiles[ player:GetName() ] = { };
		playerSettings = self.profiles[ player:GetName() ];
	end
	
	if ( Turbine.Engine:GetLocale() == "de" or Turbine.Engine:GetLocale() == "fr" ) then
		self.settings = { };
		self:deepcopyLoadConvertInts( playerSettings, self.settings );
	else
		self.settings = playerSettings;
	end

	if ( self.settings.version == nil or 
	     self.settings.version == "v1.0" or 
	     self.settings.version == "v1.1" or 
		 self.settings.version == "v1.2" or 
		 self.settings.version == "v1.3" or 
		 self.settings.version == "v1.3.1" or 
		 self.settings.version == "v1.4" or 
		 self.settings.version == "v1.5" or 
		 self.settings.version == "v1.5.1" or 
		 self.settings.version == "v1.5.2") then
		self.settings.version = THEVERSION;
	elseif (self.settings.version < "V0.6") then
		Turbine.Shell.WriteLine("Version does not match previous version. You might have difficulties and might need to delete your settings for this user.");
		self.settings.version = THEVERSION;
	end	
	if ( self.settings.bars == nil ) then
		self.settings.bars = { };
	end
	if ( self.settings.menuLanguage == nil ) then
		self.settings.menuLanguage = Turbine.Engine:GetLocale();
	end
	if ( self.settings.nextBarId == nil ) then
		self.settings.nextBarId = 1;
	end
	if ( self.settings.mainMenuVisible ~= nil ) then
		self.settings.mainMenuVisible = nil;
	end
	if ( self.settings.selectedBar == nil )then
		self.settings.selectedBar = 0;
	end
	
	return self.settings;
end

function SettingsManager:SaveSettings( profile )
	if ( Turbine.Engine:GetLocale() == "de" or Turbine.Engine:GetLocale() == "fr" ) then
		local temp = { };
		if ( profile == nil ) then
			self:deepcopySaveConvertInts( self.settings, temp );
			self.profiles[ player:GetName() ] = temp;
		else
			self:deepcopySaveConvertInts( profile, temp );
			Turbine.PluginData.Save( Turbine.DataScope.Server, "TonicBarSettings", temp );
		end
	else
		if ( profile == nil ) then
			self.profiles[ player:GetName() ] = self.settings;
		else
			Turbine.PluginData.Save( Turbine.DataScope.Server, "TonicBarSettings", profile );
		end
	end
	if ( profile == nil ) then
		Turbine.PluginData.Save( Turbine.DataScope.Server, "TonicBarSettings", self.profiles );
	end
end

function SettingsManager:GetBars( localBarType )
	if ( localBarType == nil ) then
		return self.settings.bars
	else
		self.tempBars = { };
		local i = 1;
		for key, value in pairs (self.settings.bars) do
			if ( value.barType == localBarType and value ~= nil ) then
				self.tempBars[key] = {};
				self:deepcopy( self.settings.bars[key], self.tempBars[key] );
				i = i + 1;
			end
		end
		return self.tempBars;
	end
end

function SettingsManager:GetBarSettings( barid )
	local bar = self.settings.bars[barid]
	if ( bar == nil ) then
		bar = { };
	end

	if ( bar.quickslots == nil ) then
		bar.quickslots = { };
	end
	
	if ( bar.x == nil )then
		bar.x = 103;
	end

	if ( bar.y == nil )then	
		bar.y = 161;
	end
	
	if ( bar.barType == nil )then	
		bar.barType = 1;
	end
	
	if ( bar.quickslotCount == nil )then	
		bar.quickslotCount = 5;
	end
	
	if ( bar.quickslotColumns == nil )then
		bar.quickslotColumns = 1;
	end
	
	if ( bar.quickslotRows == nil ) then
		bar.quickslotRows = bar.quickslotCount / bar.quickslotColumns;
	end
	
	if ( bar.visible == nil )then
		bar.visible = true;
	end
	
	if ( bar.locked == nil )then
		bar.locked = false;
	end
	
	if ( bar.onMouseOver == nil ) then
		bar.onMouseOver = SHOW_EXTENSIONS;
	end

	if ( bar.opacity == nil )then
		bar.opacity = 1.0;
	end
	
	if ( bar.quickslotSpacing == nil )then
		bar.quickslotSpacing = 1;
	end

	if ( bar.quickslotSize == nil )then
		bar.quickslotSize = 36;
	end

	if ( bar.useBackgroundColor == nil )then
		bar.useBackgroundColor = false;
	end	
	if ( bar.backgroundColorRed == nil )then
		bar.backgroundColorRed = 0;
	end
	if ( bar.backgroundColorGreen == nil )then
		bar.backgroundColorGreen = 0;
	end
	if ( bar.backgroundColorBlue == nil )then
		bar.backgroundColorBlue = 0;
	end
	if ( bar.useFading == nil )then
		bar.useFading = false;
	end	
	if ( bar.fadeOpacity == nil )then
		bar.fadeOpacity = 1;
	end
	if ( bar.events == nil ) then
		bar.events = { };
	end
	if ( bar.events.healthTrigger == nil )then
		bar.events.healthTrigger = 0.25;
	end
	if ( bar.events.powerTrigger == nil )then
		bar.events.powerTrigger = 0.25;
	end
	if ( bar.events.triggerOnClassBuffActive == nil ) then
		bar.events.triggerOnClassBuffActive = true;
	end
	if ( bar.events.inventory == nil )then
		bar.events.inventory = { };
	end
	if ( bar.events.inventory.quantity == nil )then
		bar.events.inventory.quantity = 50;
	end
	return bar
end

function SettingsManager:SetBarSettings(barid, bar, doNotRefresh)
	if ( barid ~= nil ) then
		self.settings.bars[barid] = bar;
	
		self:SaveSettings();
		if ( doNotRefresh == nil and maitre_d ~= nil ) then
			maitre_d:RefreshBars();
		end
	end
end

function SettingsManager:SaveQuickslots( bar, qSlots, save )
	if ( self.loading ) then
		return;
	end

	bar.quickslots = nil;
	bar.quickslots = { };

	for key, value in pairs (qSlots) do
		local shortcut = value:GetShortcut();
		if( shortcut:GetType() ~= 0 and shortcut:GetData() ~= "" ) then
			if ( bar.quickslots[key] == nil ) then
				bar.quickslots[key] = { };
			end
			bar.quickslots[key].Type = shortcut:GetType();
			bar.quickslots[key].Data = shortcut:GetData();
		end
	end
	if ( save == nil or save == false ) then
		self:SaveSettings();
	end
end

function SettingsManager:LoadQuickslots( bar, qSlots )
	self.loading = true;
	for key, value in pairs (bar.quickslots) do
		if( value.Type ~= 0 and value.Data ~= "" ) then
			local shortcut = Turbine.UI.Lotro.Shortcut( value.Type, value.Data );
			if ( pcall( SetShortcut, shortcut, qSlots, key ) == false ) then
				value = nil;
				dirty = true;
			end
		end
	end
	self.loading = false;
	
	if (dirty == true) then
		self:SaveQuickslots( bar, qSlots )
	end
end

function SetShortcut( shortcut, qSlots, key )
	qSlots[key]:SetShortcut( shortcut );
end

function SettingsManager:IncrementNextId()
	self.settings.nextBarId = self.settings.nextBarId + 1;
end


function SettingsManager:GetWrapperSettings()
	local theWrapperSettings;
	if ( self.settings.wrapperSettings ~= nil ) then
		theWrapperSettings = self.settings.wrapperSettings;
	else
		self.settings.wrapperSettings = { };
		theWrapperSettings = self.settings.wrapperSettings;
	end

	if ( type( theWrapperSettings ) ~= "table" ) then
		self.settings.wrapperSettings = { };
		theWrapperSettings = self.settings.wrapperSettings;
		local settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TonicBarWrapper", self.LoadHelper );
		if ( settings ~= nil ) then
			theWrapperSettings.positionX = settings.positionX
			theWrapperSettings.positionY = settings.positionY
			theWrapperSettings.visible   = settings.visible
			self:SetWrapperSettings( theWrapperSettings );
		end
	end

	if ( theWrapperSettings.positionX == nil ) then
		theWrapperSettings.positionX = 0;
	end

	if ( theWrapperSettings.positionY == nil ) then
		theWrapperSettings.positionY = 0;
	end
	
	if ( theWrapperSettings.visible == nil ) then
		theWrapperSettings.visible = true;
	end
	return theWrapperSettings;
end

function SettingsManager:LoadHelper()
end

function SettingsManager:SetWrapperSettings( theWrapperSettings )
	self.settings.wrapperSettings = theWrapperSettings;
	self:SaveSettings();
end

function SettingsManager:deepcopySaveConvertInts(a, b)
        if type(a) ~= "table" or type(b) ~= "table" then
                error("both parameters must be of type table but recieved " ..type(a)..
                        " and " .. type(b));
        else
                for k,v in pairs(a) do
                        -- if the type is a table, we'll need to recurse.
                        if type(v) ~= "table" then
							local l, y;
							if ( type( k ) == "number" ) then
								l = "INTEGER:" .. tostring( k );
							else
								l = k;
							end
							if ( type( v ) == "number" ) then
								y = "INTEGER:" .. tostring( v );
							else
								y = v;
							end
                            b[l] = y;
                        else
                            local x = {}
                            self:deepcopySaveConvertInts(v, x);

							local l;
							if ( type( k ) == "number" ) then
								l = "INTEGER:" .. tostring( k );
							else
								l = k;
							end
							b[l] = x;
                        end       
                end
        end
        return b;
end


function SettingsManager:deepcopyLoadConvertInts(a, b)
        if type(a) ~= "table" or type(b) ~= "table" then
                error("both parameters must be of type table but recieved " ..type(a)..
                        " and " .. type(b));
        else
                for k,v in pairs(a) do
                        -- if the type is a table, we'll need to recurse.
                        if type(v) ~= "table" then
							local l, y;
							if ( type( k ) == "string" ) then
								local temp, count = string.gsub( k, "INTEGER:", "");
								if ( count > 0 ) then
									l = tonumber( temp );
								else
									l = temp;
								end
							else
								l = k;
							end
							if ( type( v ) == "string" ) then
								local temp, count = string.gsub( v, "INTEGER:", "");
								if ( count > 0 ) then
									y = tonumber( temp );
								else
									y = temp;
								end
							else
								y = v;
							end
                            b[l] = y;
                        else
                            local x = {}
                            self:deepcopyLoadConvertInts(v, x);

							local l;
							if ( type( k ) == "string" ) then
								local temp, count = string.gsub( k, "INTEGER:", "");
								if ( count > 0 ) then
									l = tonumber( temp );
								else
									l = temp;
								end
							else
								l = k;
							end
							b[l] = x;
                        end       
                end
        end
        return b;
end

function SettingsManager:deepcopy(a, b)
        if type(a) ~= "table" or type(b) ~= "table" then
                error("both parameters must be of type table but recieved " ..type(a)..
                        " and " .. type(b));
        else
                for k,v in pairs(a) do
                        -- if the type is a table, we'll need to recurse.
                        if type(v) ~= "table" then
                                b[k] = v;
                        else
                                local x = {}
                                self:deepcopy(v, x);
                                b[k] = x;
                        end       
                end
        end
        return b;
end


function SettingsManager:GetProfiles()
	return self.profiles;
end

function SettingsManager:GetProfileBars( profile )
	return self.profiles[ profile ].bars;
end

function SettingsManager:ResetAllBars()
	self:SaveSettings();
	if ( self.settings.bars == nil ) then
		self.settings.bars = { };
	end
	maitre_d:Construct( self.settings.bars, true );
	inventoryManager:NotifyClients();
end


function SettingsManager:CopyProfile( profileToCopy, copyType, barid, myBar )
	if ( barid == nil ) then
		return;
	end

	self.profiles[ player:GetName() ] = self.settings;
	for key, value in opairs (maitre_d:GetBars()) do
		maitre_d:Remove( key, false );
	end
	self:CopyBars(profileToCopy, copyType, barid, myBar);

	self.settings = self.profiles[ player:GetName() ];
	self:ResetAllBars();
end

function SettingsManager:CopyBars(profileToCopy, copyType, barid, myBar)
	local realProfile = nil;
	local copyProfile = nil;
	if ( myBar == true ) then
		realProfile = self.profiles[ player:GetName() ];
		copyProfile = self.profiles[ profileToCopy ];
	else
		realProfile = self.profiles[ profileToCopy ]; 
		copyProfile = self.profiles[ player:GetName() ];
	end

	self:CreatePath( copyProfile );

	self:deepcopy( realProfile.bars[barid], copyProfile.bars[ copyProfile.nextBarId ] );
	
	if ( copyType == self.PARTIAL ) then
		copyProfile.bars[ copyProfile.nextBarId ].quickslots = nil;
	end

	local newQuickslotBar = copyProfile.nextBarId;
	copyProfile.nextBarId = copyProfile.nextBarId + 1;

	if ( realProfile.bars[barid].barType == QUICKSLOTBAR ) then
		for key, value in opairs ( realProfile.bars ) do
			if ( value.barType == EXTENSIONBAR and value.connectionBarID == barid ) then
				self:CreatePath( copyProfile );
				self:deepcopy( realProfile.bars[key], copyProfile.bars[ copyProfile.nextBarId ] );
				copyProfile.bars[ copyProfile.nextBarId ].connectionBarID = newQuickslotBar;
				copyProfile.nextBarId = copyProfile.nextBarId + 1;				
			end
		end
	end
end

function SettingsManager:CreatePath( copyProfile )
	if (  copyProfile == nil ) then
		 copyProfile = { };
	end
	if (  copyProfile.bars == nil ) then
		 copyProfile.bars = { };
	end
	if ( copyProfile.bars[ copyProfile.nextBarId ] == nil ) then
		copyProfile.bars[ copyProfile.nextBarId ] = { };
	end
end